# Java Fundamentals
* **Objective:**
    * To complete the method stubs in each of the provided classes
        * `MathUtilities`
    	* `PredicateUtilities`
    	* `StringUtilities`

* **Purpose:**
    * To establish familiarity with
        * [primitive data-types](http://cs.fit.edu/~ryan/java/language/java-data.html)
        * [method signatures and return statements](http://www.homeandlearn.co.uk/java/java_methods.html)
        * [String operations](https://www.tutorialspoint.com/java/java_strings.htm)
    
* **Classes to be completed:**
	* `MathUtilities`
	* `PredicateUtilities`
	* `StringUtilities`
	
* **Instructions**
    * Complete each of the method stubs in the `main` classes provided.
        * `main` classes are located in `src.main.java.com.zipcodewilmington.danny_do_better_exercises`
    * There are comments above each method stub to describe the expected behavior.
    * Begin by first ensuring the `main` method in your `ZipcodeRocks` class prints `"Zipcode Rocks!"` upon execution.  
    * Upon completion, open and run the `TestSuite` class to ensure that all tests have 100% success.
        * `TestSuite` is located in `src.test.java.com.zipcodewilmington.danny_do_better_exercises`

## Predicate Utilities
* A _predicate_ is a clause which states something about a subject. (_e.g., **is assigning**_ in _"Leon **is assigning** homework"_)
* Ensure each of the test cases passes successfully in the class [TestPredicateUtilities](./src/test/java/com/zipcodewilmington/danny_do_better_exercises/TestPredicateUtilities.java) by completing each of the method stubs in the class [PredicateUtilities](./src/main/java/com/zipcodewilmington/danny_do_better_exercises/PredicateUtilities.java).
* Method Stubs to be completed
	* `boolean isGreaterThan(int x, int y)`
	* `boolean isLessThan(int x, int y)`
	* `boolean isGreaterThanOrEqualTo(int x, int y)`
	* `boolean isLessThanOrEqualTo(int x, int y)`


## Math Utilities
* Ensure each of the test cases passes successfully in the class [TestMathUtilities](./src/test/java/com/zipcodewilmington/danny_do_better_exercises/TestMathUtilities.java) by completing each of the method stubs in the class [MathUtilities](./src/main/java/com/zipcodewilmington/danny_do_better_exercises/MathUtilities.java).
* Method Stubs to be completed	
	* `Integer add(int, int)`
	* `Long add(long, long)`
	* `Short add(short, short)`
	* `Byte add(byte, byte)`
	* `Float add(float, float)`
	* `Double add(double, double)`
	* `Integer subtract(int, int)`
	* `Long subtract(long, long)`
	* `Short subtract(short, short)`
	* `Byte subtract(byte, byte)`
	* `Float subtract(float, float)`
	* `Double subtract(double, double)`
	* `Integer divide(int, int)`
	* `Long divide(long, long)`
	* `Short divide(short, short)`
	* `Byte divide(byte, byte)`
	* `Float divide(float, float)`
	* `Double divide(double, double)`
	* `Integer multiply(int, int)`
	* `Long multiply(long, long)`
	* `Short multiply(short, short)`
	* `Byte multiply(byte, byte)`
	* `Float multiply(float, float)`
	* `Double multiply(double, double)`
	* `Boolean returnTrue`
	* `Boolean returnFalse`


## String Utilities
* Ensure each of the test cases passes successfully in the class [TestStringUtilities](./src/test/java/com/zipcodewilmington/danny_do_better_exercises/TestStringUtilities.java) by completing each of the method stubs in the class [StringUtilities](./src/main/java/com/zipcodewilmington/danny_do_better_exercises/StringUtilities.java).
* Method Stubs to be completed
	* `String concatenation(String, String)`
	* `String concatenation(int, String)`
	* `String getPrefix(String)`
	* `String getSuffix(String)`
	* `String compareTwoStrings(String)`
	* `Character getMiddleCharacter(String)`
	* `String getFirstWord(String)`
	* `String getSecondWord(String)`
	* `String reverseTheTwo(String)`